.retry: &retry
  retry:
    max: 2
    when: script_failure

.deployer: &deployer
  image: registry.gitlab.com/commonground/huishoudboekje/review-app-deployer:latest

.authorize-azure-ad: &authorize-azure-ad
  stage: deploy
  image: mcr.microsoft.com/azure-cli:2.62.0

deploy-deployment-test:
  <<: *deployer
  <<: *retry
  stage: deploy
  needs:
    - build-images-dev
  environment:
    name: test
    url: https://test.hhb-development.nl/
  variables:
    APP_HOST: "test.hhb-development.nl"
    NAMESPACE: "hhb-test"
    OIDC_BASE_URL: "https://test.hhb-development.nl"
    JWT_ALGORITHMS: HS256,RS256
  script:
    # Deploy
    - bash ./k8s/apply-env-vars.sh
    - kubectl config use-context commonground/huishoudboekje/app-new:hhb-development
    - kubectl create ns $NAMESPACE || true
    - kubectl kustomize ./k8s/overlays/hhb-development-cluster/overlays/test
    - kubectl apply -k ./k8s/overlays/hhb-development-cluster/overlays/test --namespace=$NAMESPACE
  rules:
    - if: $CI_COMMIT_BRANCH == "develop"

deploy-deployment-review:
  <<: *deployer
  <<: *retry
  needs:
    - build-images-dev
    - authorize-azure-ad-review
  dependencies:
    - authorize-azure-ad-review
  stage: deploy
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    url: https://hhb-$CI_COMMIT_REF_SLUG.review.hhb-development.nl/
    on_stop: destroy-review
    auto_stop_in: 7 days
  variables:
    APP_HOST: "hhb-$CI_COMMIT_REF_SLUG.review.hhb-development.nl"
    NAMESPACE: "hhb-$CI_COMMIT_REF_SLUG"
    OIDC_BASE_URL: "https://hhb-$CI_COMMIT_REF_SLUG.review.hhb-development.nl"
    JWT_ALGORITHMS: HS256,RS256
  script:
    - bash ./k8s/apply-env-vars.sh
    - kubectl config use-context commonground/huishoudboekje/app-new:hhb-development
    - kubectl create ns $NAMESPACE || true
    - kubectl kustomize ./k8s/overlays/hhb-development-cluster/overlays/review
    - kubectl apply -k ./k8s/overlays/hhb-development-cluster/overlays/review --namespace=$NAMESPACE
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'

authorize-azure-ad-review:
  <<: *authorize-azure-ad
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    on_stop: unauthorize-azure-ad-review
  variables:
    GITLAB_API_URL: "https://gitlab.com/api/v4"
    EVIRONMENT_NAME: "review/$CI_COMMIT_REF_SLUG"
    APP_HOST: "hhb-$CI_COMMIT_REF_SLUG.review.hhb-development.nl"
    APP_API_URI: "api://$CI_COMMIT_REF_SLUG"
  script:
    - apk add --no-cache curl  # Install curl
    - sh ./pipeline/scripts/authorize-azure-ad.sh
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'

unauthorize-azure-ad-review:
  <<: *authorize-azure-ad
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    action: stop
  needs:
    - authorize-azure-ad-review
  dependencies:
    - authorize-azure-ad-review
  variables:
    GIT_STRATEGY: none # the runner won’t try to check out the code after the branch is deleted.
    APP_HOST: "hhb-$CI_COMMIT_REF_SLUG.review.hhb-development.nl"
    GITLAB_API_URL: "https://gitlab.com/api/v4"
    EVIRONMENT_NAME: "review/$CI_COMMIT_REF_SLUG"
  script:
    - apk add --no-cache curl  # Install curl
    - az login --service-principal -u $AZURE_CLIENT_ID -p $AZURE_CLIENT_SECRET --tenant $AZURE_TENANT_ID
    - az ad app delete --id "$AZURE_APP_ID"
    # Delete variables  
    - |
      function delete_variable {
        curl --request DELETE --globoff --header "PRIVATE-TOKEN: $GITLAB_ACCESS_TOKEN" \
            "$GITLAB_API_URL/projects/$CI_PROJECT_ID/variables/$1?filter[environment_scope]=$EVIRONMENT_NAME"
      }
    - delete_variable AZURE_APP_SCOPE
    - delete_variable AZURE_APP_ID
    - delete_variable AZURE_APP_SECRET
  when: manual
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    

## Destroy app (only review cluster)
destroy-review:
  <<: *deployer
  stage: deploy
  needs:
    - deploy-deployment-review
  environment:
    name: review/$CI_COMMIT_REF_SLUG
    action: stop
  variables:
    GIT_STRATEGY: none # the runner won’t try to check out the code after the branch is deleted.
    NAMESPACE: "hhb-$CI_COMMIT_REF_SLUG"
    APP_HOST: "hhb-$CI_COMMIT_REF_SLUG.review.hhb-development.nl"
  before_script:
    - kubectl config use-context commonground/huishoudboekje/app-new:hhb-development
  script:
    - kubectl delete namespace ${NAMESPACE}
  when: manual
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
